#ifndef BU_MYRIAD_STREAM_H
#define BU_MYRIAD_STREAM_H

#include "bu/stream.h"
#include "bu/myriadstream.h"
#include "bu/myriad.h"

namespace Bu
{
    class MyriadStream : public Bu::Stream
    {
    friend class Myriad;
    private:
        MyriadStream( Bu::Myriad &rMyriad, Bu::Myriad::Stream *pStream,
                Bu::Myriad::Mode eMode );
    public:
        virtual ~MyriadStream();
    
    public:
        virtual void close();
        virtual size read( void *pBuf, size iBytes );
        virtual size write( const void *pBuf, size iBytes );
        using Stream::write;
        virtual size tell();
        virtual void seek( size offset );
        virtual void setPos( size pos );
        virtual void setPosEnd( size pos );
        virtual bool isEos();
        virtual bool isOpen();
        virtual void flush();
        virtual bool canRead();
        virtual bool canWrite();
        virtual bool isReadable();
        virtual bool isWritable();
        virtual bool isSeekable();
        virtual bool isBlocking();
        virtual void setBlocking( bool bBlocking=true );
        virtual void setSize( size iSize );
        virtual size getSize() const;
        virtual size getBlockSize() const;
        virtual Bu::String getLocation() const;
        Myriad::StreamId getId() const;

    private:
        mutable Bu::Mutex mAccess;
        Bu::Myriad &rMyriad;
        Bu::Myriad::Stream *pStream;
        Bu::Myriad::Mode eMode;
        int32_t iPos;
    };
};

#endif
